# faced

faced is a light-weight library to identify faces and it's features such as eyes, nose and mouth. It requires opencv.

## Install
`npm install faced`

## Identify your first face

```javascript
var faced = new Faced();
faced.detect('image.jpg', function (faces, image) {
  if (!faces) {
    return console.log("No faces found!");
  }

  var face = sface[0];

  console.log(
    "Found a face at %d,%d with dimensions %dx%d",
    face.getX(),
    face.getY(),
    face.getWidth(),
    face.getHeight()
  );

  console.log(
    "What a pretty face, it %s a mouth, it %s a nose, it % a left eye and it %s a right eye!",
    face.getMouth() ? "has" : "does not have",
    face.getNose() ? "has" : "does not have",
    face.getEyeLeft() ? "has" : "does not have",
    face.getEyeRight() ? "has" : "does not have",
  );
});
```

## API

### Faced.detect(path, function, context)

Loads an image from the given `path` and executes `function` upon completion.

If there were no issues loading the image you should receive two arguments to your function, `function (faces, image) { }`, the first is an array of `Face` whereas the second is a `Matrix` [object from opencv](https://npmjs.org/package/opencv#readme).

In case of error, the callback function is called with no arguments.

### Class `Feature`
 - `Feature.getX()` Returns the upper X position of the face
 - `Feature.getY()` Returns the upper Y position of the face
 - `Feature.getX2()` Returns the lower X position of the face
 - `Feature.getY2()` Returns the lower Y position of the face
 - `Feature.getWidth()` Returns the width
 - `Feature.getHeight()` Returns the height
 - `Feature.intersect(Feature)` Returns the percentage of shared spaced that the current feature has with the given argument Feature. *Although this is used internally it might be useful for client usage.*

### Class `Face` (extends `Feature`)

All of the following method1s return an instance of `Feture` or `undefined` if it could not detect.

 - `Face.getMouth()`
 - `Face.getNose()`
 - `Face.getEyeLeft()`
 - `Face.getEyeRight()`

Other significant methods

 - `Face.getFeature(name)` Returns a feature by name. Possible names are: `mouth`, `nose`, `eyeLeft` and `eyeRight`.
 - `Face.getFeatures()` Returns an array of `Feature` that the instance has detected.
 - `Face.getFeatureCount()` Returns the number of detected features.

## Examples

```bash
$ node examples/gioconda.js
```

Then open `examples/gioconda.features.jpg` on your favourite image viewer.

## Information

#### License

node-faced is licensed under the [MIT license](http://opensource.org/licenses/MIT)

#### Copyright

Copyright (c) 2013, Samuel Gordalina <samuel.gordalina@gmail.com>